use lavina_core::prelude::Str;
use lavina_core::repo::Storage;
use proto_irc::response::SendResponseBody;
use std::future::Future;
use tokio::io::AsyncWrite;

pub mod whois;

struct HandlerY<T: AsyncWrite + Unpin> {
    server_name: Str,
    client: Str,
    writer: T,
    storage: Storage,
}

pub trait Handler {
    fn handle(
        &self,
        server_name: &Str,
        client: &Str,
        writer: &mut (impl AsyncWrite + Unpin),
        storage: &mut Storage,
    ) -> impl Future<Output = anyhow::Result<()>>;
}
