use tokio::io::{AsyncWrite, AsyncWriteExt};

use lavina_core::prelude::Str;
use proto_irc::response::SendResponseBody;

struct RplWhoisCertfp276;
struct RplWhoisRegNick307;
pub struct RplWhoIsUser311 {
    client: Str,
    /// unique name
    nick: Str,
    /// username not unique
    username: Option<Str>,
    /// server name
    host: Str,
}

impl RplWhoIsUser311 {
    pub fn new(client: Str, nick: Str, username: Option<Str>, host: Str) -> Self {
        RplWhoIsUser311 {
            client,
            nick,
            username,
            host,
        }
    }
}

struct _RplWhoisServer312;
struct _RplWhoisOperator313;
struct _RplWhoisIdle317;
struct _RplWhoisChannels319;
struct _RplWhoisSpecial320;
struct _RplWhoisAccount330;
struct _RplWhoisActually338;
struct _RplWhoisHost378;
struct _RplWhoisModes379;
struct _RplWhoisSecure671;
struct _RplAway301;
pub struct RPL_ENDOFWHOIS_318 {
    client: Str,
    nick: Str,
}
impl RPL_ENDOFWHOIS_318 {
    pub fn new(client: Str, nick: Str) -> Self {
        RPL_ENDOFWHOIS_318 { client, nick }
    }
}

impl SendResponseBody for RplWhoIsUser311 {
    async fn write_response(self, writer: &mut (impl AsyncWrite + Unpin)) -> std::io::Result<()> {
        writer.write_all(b"311 ").await?;
        writer.write_all(self.client.as_bytes()).await?;
        writer.write_all(b" ").await?;
        writer.write_all(self.nick.as_bytes()).await?;
        if let Some(username) = self.username {
            writer.write_all(b" ").await?;
            writer.write_all(username.as_bytes()).await?;
        }
        writer.write_all(b" ").await?;
        writer.write_all(self.host.as_bytes()).await?;
        writer.write_all(b" ").await?;
        writer.write_all("*".as_bytes()).await?;
        writer.write_all(b" ").await?;
        writer.write_all(b" :").await?;
        //todo no entity in db that represents whole irc user entity
        writer.write_all("<realname>".as_bytes()).await?;

        Ok(())
    }
}

impl SendResponseBody for RPL_ENDOFWHOIS_318 {
    async fn write_response(self, writer: &mut (impl AsyncWrite + Unpin)) -> std::io::Result<()> {
        writer.write_all(b"318 ").await?;
        writer.write_all(self.client.as_bytes()).await?;
        writer.write_all(b" ").await?;
        writer.write_all(self.nick.as_bytes()).await?;
        writer.write_all(b" :").await?;
        writer.write_all("End of /WHOIS list".as_bytes()).await?;
        Ok(())
    }
}
